<script lang="ts">
  const isValidEmail = (email: string) => /^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(email);

  let emailInput: HTMLInputElement;
  let defaultPlaceHolder = 'Email Address';
  let placeholder = defaultPlaceHolder;

  const onSubmit = () => {
    resetPlaceholder();

    if (!isValidEmail(emailInput.value)) {
      emailInput.focus();
      return;
    }

    emailInput.value = '';
    placeholder = 'Thanks for subscribing!';
  };

  const resetPlaceholder = () => {
    placeholder = defaultPlaceHolder;
  };
</script>

<div class="container">
  <span class="block text-lg font-semibold">Stay Updated!</span>
  <spn>Subscribe to our newsletter</spn>
  <div class="email-container">
    <form on:submit|preventDefault={onSubmit}>
      <input
        bind:this={emailInput}
        class="email-input"
        {placeholder}
        on:click={resetPlaceholder} />
    </form>
    <button on:click={onSubmit}>Submit</button>
  </div>
</div>

<style lang="postcss">
  .container {
    width: 100%;
    padding: var(--content-margin);
  }

  .email-input {
    width: 100%;
    padding: 10px;
    border: 1px solid hsl(0deg 0% 80%);
    border-radius: var(--radius-1);
    margin-bottom: 10px;
    background-color: transparent;
    transition: 0.5s;

    &:focus {
      border: 1px solid hsl(0deg 0% 33%);
      background-color: white;
    }
  }

  button {
    width: 100%;
    padding: 10px;
    border-radius: var(--radius-1);
    background-image: linear-gradient(
      to right,
      hsl(180deg 90% 48%) 0%,
      hsl(165deg 78% 51%) 51%,
      hsl(180deg 90% 48%) 100%
    );
    color: white;
    font-weight: bold;
    transition: 0.5s;

    &:hover {
      background-position: right center;
      text-decoration: none;
    }
  }
</style>
